-- MySQL Script generated by MySQL Workbench
-- Mon Apr 11 02:56:47 2022
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema dwh
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `dwh` ;

-- -----------------------------------------------------
-- Schema dwh
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `dwh` DEFAULT CHARACTER SET utf8 ;
USE `dwh` ;

-- -----------------------------------------------------
-- Table `dwh`.`dim_date`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`dim_date` ;

CREATE TABLE IF NOT EXISTS `dwh`.`dim_date` (
  `sid` INT NOT NULL,
  `date_key` INT NULL,
  `date` DATE NULL,
  `julian_date` INT NULL,
  `isweekend` INT NULL,
  `isworkday` INT NULL,
  `weekend_text` CHAR(10) NULL DEFAULT 'Weekday',
  `day_of_week_full` CHAR(10) NULL,
  `day_of_week_short` CHAR(3) NULL,
  `day_of_week` INT NULL,
  `month` INT NULL,
  `month_full` CHAR(10) NULL,
  `month_short` CHAR(3) NULL,
  `first_date_of_month` DATE NULL,
  `last_date_of_month` DATE NULL,
  `days_in_month` INT NULL,
  `day_of_month` INT NULL,
  `day_of_month_text` CHAR(5) NULL,
  `quarter` INT NULL,
  `year` INT NULL,
  `year_month_number` INT NULL,
  `year_week_number` INT NULL,
  `day_of_year` INT NULL,
  `week_starting_monday` CHAR(2) NULL,
  PRIMARY KEY (`sid`),
  UNIQUE INDEX `uniq_date_key` (`date_key` ASC) VISIBLE,
  INDEX `idx_month` (`month` ASC) VISIBLE,
  INDEX `idx_year` (`year` ASC) VISIBLE,
  INDEX `idx_quarter` (`quarter` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`dim_exchange_rate`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`dim_exchange_rate` ;

CREATE TABLE IF NOT EXISTS `dwh`.`dim_exchange_rate` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `date_key` INT NULL,
  `exchange_from` VARCHAR(50) NULL DEFAULT 'AED',
  `exchange_to` VARCHAR(50) NULL DEFAULT 'SAR',
  `exchange_rate` DECIMAL(10,5) NULL,
  PRIMARY KEY (`sid`),
  INDEX `combo_date_exchange_from` (`date_key` ASC, `exchange_from` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`dim_order`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`dim_order` ;

CREATE TABLE IF NOT EXISTS `dwh`.`dim_order` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `order_id` VARCHAR(36) NOT NULL,
  `order_number` VARCHAR(50) NOT NULL,
  `merchant_name` VARCHAR(255) NULL,
  `country_code` VARCHAR(2) NULL,
  `description` VARCHAR(255) NULL,
  `payment_type` VARCHAR(150) NULL,
  `status` VARCHAR(20) NULL,
  `platform` VARCHAR(128) NULL,
  `is_mobile` TINYINT(1) NULL,
  `device_id` VARCHAR(50) NULL,
  `created_at` DATETIME NULL,
  `updated_at` DATETIME NULL,
  `created_date_key` INT NULL,
  `updated_date_key` INT NULL,
  `is_current` TINYINT(1) NULL DEFAULT 1,
  PRIMARY KEY (`sid`),
  INDEX `comb_idx_current_order` (`order_id` ASC, `is_current` ASC, `status` ASC) VISIBLE,
  INDEX `idx_order_number` (`order_number` ASC) VISIBLE,
  INDEX `idx_created_date_key` (`created_date_key` ASC) VISIBLE,
  INDEX `idx_updated_date_key` (`updated_date_key` ASC) VISIBLE,
  INDEX `idx_merchant` (`merchant_name` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`dim_order_item`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`dim_order_item` ;

CREATE TABLE IF NOT EXISTS `dwh`.`dim_order_item` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `order_event_id` BIGINT NULL,
  `sku` VARCHAR(50) NULL,
  `name` VARCHAR(255) NULL,
  `order_id` VARCHAR(36) NULL,
  `type` VARCHAR(50) NULL,
  `image_url` VARCHAR(255) NULL,
  `reference_id` VARCHAR(50) NULL,
  `created_date_key` INT NULL,
  `merchant_id` VARCHAR(36) NULL,
  `merchant_name` VARCHAR(255) NULL,
  PRIMARY KEY (`sid`),
  INDEX `idx_sku_name` (`sku` ASC, `name` ASC) VISIBLE,
  INDEX `idx_order_id` (`order_id` ASC) VISIBLE,
  INDEX `idx_merchant_id` (`merchant_id` ASC) VISIBLE,
  INDEX `idx_merchant_name` (`merchant_name` ASC) VISIBLE,
  INDEX `idx_created_date_key` (`created_date_key` ASC) VISIBLE,
  INDEX `idx_order_event_id` (`order_event_id` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`fact_order`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`fact_order` ;

CREATE TABLE IF NOT EXISTS `dwh`.`fact_order` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `order_id` VARCHAR(36) NULL,
  `created_date_key` INT NULL,
  `updated_date_key` INT NULL,
  `total_amount` BIGINT NULL,
  `total_currency` VARCHAR(3) NULL,
  `is_current` TINYINT(1) NULL DEFAULT 1,
  PRIMARY KEY (`sid`),
  INDEX `combo_idx_current_order` (`order_id` ASC, `is_current` ASC) VISIBLE,
  INDEX `idx_created_date_key` (`created_date_key` ASC) VISIBLE,
  INDEX `idx_updated_dated_key` (`updated_date_key` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`fact_order_event`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`fact_order_event` ;

CREATE TABLE IF NOT EXISTS `dwh`.`fact_order_event` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `order_event_id` BIGINT NULL,
  `event_id` VARCHAR(36) NULL,
  `order_id` VARCHAR(36) NULL,
  `event_name` VARCHAR(255) NULL,
  `created_at` DATETIME NULL,
  `created_date_key` INT NULL,
  PRIMARY KEY (`sid`),
  INDEX `idx_order_event` (`order_event_id` ASC) VISIBLE,
  INDEX `idx_event_id` (`event_id` ASC) VISIBLE,
  INDEX `idx_order_id` (`order_id` ASC) VISIBLE,
  INDEX `idx_created_date_key` (`created_date_key` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`fact_order_item`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`fact_order_item` ;

CREATE TABLE IF NOT EXISTS `dwh`.`fact_order_item` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `order_event_id` BIGINT NULL,
  `event_id` VARCHAR(36) NULL,
  `order_id` VARCHAR(36) NULL,
  `sku` VARCHAR(50) NULL,
  `name` VARCHAR(255) NULL,
  `quantity` INT NULL,
  `tax_amount` DECIMAL(10,2) NULL,
  `tax_currency` VARCHAR(3) NULL,
  `unit_price` DECIMAL(10,2) NULL,
  `unit_currency` VARCHAR(45) NULL,
  `total_amount` DECIMAL(10,2) NULL,
  `total_currency` VARCHAR(3) NULL,
  `discount_amount` DECIMAL(10,2) NULL,
  `discount_currency` VARCHAR(3) NULL,
  `created_date_key` INT NULL,
  `merchant_id` VARCHAR(36) NULL,
  `merchant_name` VARCHAR(255) NULL,
  PRIMARY KEY (`sid`),
  INDEX `idx_order_event_id` (`order_event_id` ASC) VISIBLE,
  INDEX `idx_event_id` (`event_id` ASC) VISIBLE,
  INDEX `idx_order_id` (`order_id` ASC) VISIBLE,
  INDEX `combo_sku_name` (`sku` ASC, `name` ASC) VISIBLE,
  INDEX `idx_merchant_id` (`merchant_id` ASC) VISIBLE,
  INDEX `idx_merchant_name` (`merchant_name` ASC) VISIBLE,
  INDEX `idx_created_date_key` (`created_date_key` ASC) VISIBLE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `dwh`.`fact_order_overdue`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `dwh`.`fact_order_overdue` ;

CREATE TABLE IF NOT EXISTS `dwh`.`fact_order_overdue` (
  `sid` INT NOT NULL AUTO_INCREMENT,
  `order_event_id` BIGINT NULL,
  `event_id` VARCHAR(36) NULL,
  `order_id` VARCHAR(36) NULL,
  `capture_id` VARCHAR(36) NULL,
  `payment_id` VARCHAR(36) NULL,
  `recorded_at` DATETIME NULL,
  `recorded_date_key` INT NULL,
  `late_fee_amount` DECIMAL(10,2) NULL,
  `late_fee_currency` CHAR(3) NULL,
  PRIMARY KEY (`sid`),
  INDEX `idx_order_event` (`order_event_id` ASC) VISIBLE,
  INDEX `idx_event_id` (`event_id` ASC) VISIBLE,
  INDEX `idx_order_id` (`order_id` ASC) VISIBLE,
  INDEX `idx_recorded_date_key` (`recorded_date_key` ASC) VISIBLE)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
